# Default image, if not specified
image: "nixpkgs/nix-flakes"

stages:
  - build

# Defaults for images running on on-prem runners using a (massive) docker image containing vivado
# This doesn't fit into cloud runners, hence on-prem
.vivado:
  before_script:
    # Store the CI_JOB_TOKEN so that jobs can access other repositories with the access rights of the triggering user:
    - echo -e "machine ${CI_SERVER_HOST}\nlogin gitlab-ci-token\npassword ${CI_JOB_TOKEN}" > ~/.netrc
    # Set up git so that test commits don't fail
    - echo [user] > ~/.gitconfig
    - echo name = Gitlabs CI Testing >> ~/.gitconfig
    - echo email = test@example.com >> ~/.gitconfig
    # Allow /opt as sandbox
    - mkdir -p ~/.local/share/nix
    - echo '{"extra-sandbox-paths":{"/opt":true}}' > ~/.local/share/nix/trusted-settings.json
    # Set up nix env vars (not part of the docker image by default):
    - source ~/.nix-profile/etc/profile.d/nix.sh
    # Install cachix
    - nix profile install nixpkgs/nixos-22.11#cachix
    # If a Cachix cache was passed, use it
    - if [ ! -z '$CACHIX_CACHE_NAME' ]; then cachix use --mode user-nixconf $CACHIX_CACHE_NAME; fi

  image: registry.gitlab.com/aion-physics/code/vivado-docker:2022.2
  tags:
    - gateware
    - largehd
    - docker
    - largeRAM
  stage: build

.nixbuilder:
  extends: .vivado
  script:
    - mkdir outputs
    - nix build --impure --print-build-logs .#images.${NIX_BUILD_TARGET}
    - cp -r result/* ./outputs/
    # Push to cachix too
    - nix build --impure --print-out-paths .#images.${NIX_BUILD_TARGET} | cachix push $CACHIX_CACHE_NAME
  artifacts:
    when: always
    paths:
    - outputs


echo_debug:
  stage: .pre
  script:
    - printenv
  rules:
    - if: "$CI_DEBUG_TRACE"
      when: always
